/*
    Name............layerRounder.jsx    
    Version.........1.2
    Author..........www.sweetberry.com
    Description.....レイヤーを分割して丸め込みます。3Dカメラの背景に便利。
    Support.........6.5/7.0/CS3
*/	
	{
		/*---------------------------------------------------------------------------------------------------------*/
		function initGlobals(G)
				/*---------------------------------------------------------------------------------------------------------*/
		{		
			G.NAME				=  "layerRounder.jsx";
			G.VERSION			=   "1.2";
			G.TITLE				=   "Layer Rounder";
			G.AUTHOR			=   "www.sweetberry.com";
			G.DESCRIPTION	=   "レイヤーを分割して丸め込みます。3Dカメラの背景に便利";
			G.ABOUT			=   "\"" + G.NAME + "\", v" + G.VERSION + "\r" + G.AUTHOR + "\r\r" + G.DESCRIPTION;
			/*---------------------------------------------------------------------------------------------------------*/
			G.AMOUNTSLICELAYERS_DEFAULTS		=	"10";
			G.AMOUNTSLICELAYERS						=	G.AMOUNTSLICELAYERS_DEFAULTS;
			G.AMOUNTSLICELAYERS_EFFECTS_NAME	= "Amount Slices";
			G.ROUND_EFFECTS_NAME						=	"Round";
			G.CONTROLLER_LAYER_NAME				=	"Controller";
			G.SLICE_MAKER_STR							=	"sliceLayer";
			G.CONTROLLER_MAKER_STR					=	"sliceレイヤーの真上に置いてください。/ slice数やroundのコントローラーはこちら";
			G.CENTER_MAKER_STR							=	"全体の移動などはこちらで";
			/*---------------------------------------------------------------------------------------------------------*/
			G.CONTROLLER_POS_EXPR		=	"amountSlices = thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.AMOUNTSLICELAYERS_EFFECTS_NAME+"\")(1);\r"+
															"if(amountSlices<1){amountSlices=1;}\r"+
															"oneOrient = (360/amountSlices)*thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.ROUND_EFFECTS_NAME+"\")(1)*0.01;\r"+
															"temp1 = Math.sin(degreesToRadians((180-oneOrient)*0.5))*thisComp.layer(thisLayer,1).width/amountSlices;\r"+
															"temp2 = Math.sin(degreesToRadians(oneOrient));\r"+
															"if(temp2 == 0){temp2 = 0.0000001;}\r"+
															"r = temp1/temp2;\r"+
															"X = -Math.sin(degreesToRadians(oneOrient*amountSlices*0.5))*r;\r"+
															"if(oneOrient==0){X = -thisComp.layer(thisLayer,1).width*0.5;}\r"+
															"Z=0;\r"+
															"//centerのz位置を変化させたい場合は下の行をコメントアウトしてください。\r"+
															"//if(thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.ROUND_EFFECTS_NAME+"\")(1)>50){Z = -r*(thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.ROUND_EFFECTS_NAME+"\")(1)-50)*0.02; }\r"+
															"value+[X,0,Z];";
			G.CONTROLLER_ROT_EXPR		=	"-180*thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.ROUND_EFFECTS_NAME+"\")(1)*0.01;";
			G.ANCHOR_EXPR						=	"Y = value[1];\r"+
															"Z = value[2];\r"+
															"amountSlices = thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.AMOUNTSLICELAYERS_EFFECTS_NAME+"\")(1);\r"+
															"if(amountSlices<1){amountSlices=1;}\r"+
															"X = (width/amountSlices)*(index - parent.index-1);\r"+
															"[X,Y,Z];";
			G.POS_EXPR							=	"amountSlices = thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.AMOUNTSLICELAYERS_EFFECTS_NAME+"\")(1);\r"+
															"if(amountSlices<1){amountSlices=1;}\r"+
															"oneOrient = (360/amountSlices)*thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.ROUND_EFFECTS_NAME+"\")(1)*0.01;\r"+
															"temp1 = Math.sin(degreesToRadians((180-oneOrient)*0.5))*width/amountSlices;\r"+
															"temp2 = Math.sin(degreesToRadians(oneOrient));\r"+
															"if(temp2 == 0){temp2 = 0.0000001;}\r"+
															"r=temp1/temp2;\r"+
															"if(oneOrient==0){oneOrient=0.01;}\r"+
															"Z = r*Math.cos(degreesToRadians(oneOrient*(index - parent.index-1)))-r;\r"+
															"X = r*Math.sin(degreesToRadians(oneOrient*(index - parent.index-1)));\r"+
															"[X,0,Z];";
			G.ORI_EXPR							=	"X = value[0];\r"+
															"Z = value[2];\r"+
															"amountSlices = thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.AMOUNTSLICELAYERS_EFFECTS_NAME+"\")(1);\r"+
															"if(amountSlices<1){amountSlices=1;}\r"+
															"Y = (360/amountSlices)*(index - parent.index)*thisComp.layer(\""+G.CONTROLLER_LAYER_NAME+"\").effect(\""+G.ROUND_EFFECTS_NAME+"\")(1)*0.01;\r"+
															"[X,Y,Z];";
			/*---------------------------------------------------------------------------------------------------------*/
			G.NO_PROJ_ERR			=  "プロジェクトを開いてください";
			G.NO_COMP_ERR		=  "スライスするレイヤーを選択してください";
			G.NO_LAYERS_ERR		=  "スライスするレイヤーを選択してください";
			G.OVER_LAYERS_ERR	=  "複数のレイヤーは指定できません";
			G.WARNING				=	"このスクリプトを実行すると複数のレイヤーが生成されます\r他のレイヤー構造に干渉し、\r予期せぬ結果をもたらす可能性がありますが実行しますか？";
		}
		
		/*---------------------------------------------------------------------------------------------------------*/
		function createUI(thisObj) 
				/*---------------------------------------------------------------------------------------------------------*/
		{
			// palette
			if( thisObj instanceof Panel == true) {var myPalette = thisObj;}
			else{
				var myPalette = new Window("palette", G.TITLE, [0,0,200,135],{resizeable:true});
				myPalette.center();
				myPalette.show();
			}
			// about button
			myPalette.aboutBtn = myPalette.add("button", [10,105,80,125], "About...");
			
			// settings panel
			myPalette.settingsPnl = myPalette.add("panel", [10,10,190,100]);
			
			myPalette.settingsPnl.add("statictext", [10,12,80,30], "スライス数:");
			myPalette.settingsPnl.amountSliceLayersEdt = myPalette.settingsPnl.add("edittext", [75,10,100,28], G.AMOUNTSLICELAYERS_DEFAULTS);
			
			myPalette.createBtn = myPalette.settingsPnl.add("button", [10,35,160,75], "Create");
			
			// events
			myPalette.aboutBtn.onClick = function ()
			{
				alert(G.ABOUT);
			}
			
			myPalette.settingsPnl.amountSliceLayersEdt.onChange = function ()
			{
				var dataIn = this.text;
				if (isNaN(dataIn) || parseInt(dataIn) < 1)
				{
					alert("スライス数は、1以上の数字で指定してください");
					this.text = G.AMOUNTSLICELAYERS_DEFAULTS;
				}else{
					this.text = Math.round(dataIn);
				}
			}
			
			myPalette.createBtn.onClick = Main;
			
			return myPalette;
		}
		
		/*---------------------------------------------------------------------------------------------------------*/
		function createSliceLayers(comp, layers)
		/*---------------------------------------------------------------------------------------------------------*/
		{
			var compCenter = [comp.width / 2, comp.height / 2, 0];
			
			var controllerLayer = comp.layers.addNull();
			controllerLayer.name = G.CONTROLLER_LAYER_NAME;
			controllerLayer.threeDLayer = true;
			var controllerMarker = new MarkerValue(G.CONTROLLER_MAKER_STR);               
			controllerLayer.Marker.setValueAtTime(controllerLayer.inPoint, controllerMarker);
			
			var centerLayer = comp.layers.addNull();
			centerLayer.name = "Center";
			centerLayer.threeDLayer = true;
			centerLayer.position.setValue(compCenter);
			var centerMarker = new MarkerValue(G.CENTER_MAKER_STR);               
			centerLayer.Marker.setValueAtTime(centerLayer.inPoint, centerMarker);
			
			centerLayer.moveBefore(layers[0]);
			controllerLayer.moveBefore(layers[0]);

			controllerLayer.parent = centerLayer;
			
			var amountSliceLayersEffects = controllerLayer.Effects.addProperty("ADBE Slider Control");
			amountSliceLayersEffects.name = G.AMOUNTSLICELAYERS_EFFECTS_NAME;
			amountSliceLayersEffects.property(1).setValue(UI.settingsPnl.amountSliceLayersEdt.text);
			
			var roundEffects = controllerLayer.Effects.addProperty("ADBE Slider Control");
			roundEffects.name = G.ROUND_EFFECTS_NAME;
			roundEffects.property(1).setValue(50);
			
			controllerLayer.position.expression = G.CONTROLLER_POS_EXPR;
			controllerLayer.yRotation.expression = G.CONTROLLER_ROT_EXPR;
			
			var sliceMarker = new MarkerValue(G.SLICE_MAKER_STR);               
            layers[0].Marker.setValueAtTime(layers[0].inPoint, sliceMarker);
			layers[0].threeDLayer = true;
			layers[0].parent = controllerLayer;
			layers[0].anchorPoint.expression = G.ANCHOR_EXPR;
			layers[0].position.expression = G.POS_EXPR;
			layers[0].orientation.expression = G.ORI_EXPR;
			
			for(i=1;i<parseInt(UI.settingsPnl.amountSliceLayersEdt.text);i++)
			{
				layers[0].duplicate(). moveAfter(layers[0]);
			}	
		}
		/*---------------------------------------------------------------------------------------------------------*/
		function Main() 
		/*---------------------------------------------------------------------------------------------------------*/
		{
			var proj = app.project;
			if (!proj)
			{
				alert(G.NO_PROJ_ERR);
				return;
			}        
			var comp = proj.activeItem;
			if (!comp || !(comp instanceof CompItem))
			{
				alert(G.NO_COMP_ERR);
				return;
			}        
			if (comp.selectedLayers.length < 1)
			{
				alert(G.NO_LAYERS_ERR);
				return;  
			}
			if (comp.selectedLayers.length > 1)
			{
				alert(G.OVER_LAYERS_ERR);
				return;  
			}
			if (comp.numLayers > comp.selectedLayers.length)
			{
				if (!confirm(G.WARNING,true,G.TITLE))
				{
					return;
				}
			}
			
			var selLayers = comp.selectedLayers;
			G.LAYERS_PER_SLICE  = parseInt(UI.settingsPnl.amountSliceLayersEdt.text);
			
			app.beginUndoGroup(G.TITLE);
			
			createSliceLayers(comp, selLayers);
			
			app.endUndoGroup();
		}
		/*---------------------------------------------------------------------------------------------------------*/
		// Entry Point
		/*---------------------------------------------------------------------------------------------------------*/
		var G = new Object();
		initGlobals(G);
		var UI = createUI(this);
		
	}